<?php

/**
 * AWtomator IPN Sender for SMF
 * By Rob Woodgate
 * (c) 2017 Cogmentis Ltd
 *
 * Please note that this is a proof-of-concept plugin, so there are no settings screens
 * Secret key and Instant Notification URL must be set below
 *
 */

/**
 * CONFIG: SET SECRET KEY AND NOTIFICATION URL HERE
 */

define('AWTOMATOR_NOTIFY_URL', 'https://www.awtomator.com/n/abc123');
define('AWTOMATOR_SECRET_KEY', 'somerandomstringofyourchoice');

//* END CONFIG: NO MORE EDITS BELOW HERE!

/**
 * Takes the registration data from SMF and sends to AWtomator
 *
 * @param array &$regOptions Array of Registration data
 * @param array &$theme_vars Theme specific options (we don't use these)
 * @return void
 *
 */
function awtomator_post_ipn(&$regOptions, &$theme_vars) {

    // Check CURL is enabled
    if ( !function_exists('curl_version') ) {
        error_log('AWtomatorIPN sender for SMF failed because CURL is not enabled on this server');
        return;
    }

    $url = filter_var(AWTOMATOR_NOTIFY_URL, FILTER_VALIDATE_URL);
    $req = $regOptions['register_vars'];
    $req['secret_key'] = AWTOMATOR_SECRET_KEY;
    $req = http_build_query($req, '', '&');

    if ( !empty($url) && 'https://www.awtomator.com/n/abc123' != $url ) {
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
        curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));
        curl_exec($ch);
        curl_close($ch);
    } else {
        error_log('AWtomatorIPN sender for SMF failed. AWTOMATOR_NOTIFY_URL is not set');
    }
}